var _ = require("lodash");

module.exports = function parallel(functions, done) {
    var wait, closed, complete;

    complete = 0;
    wait = functions.length;

    function reject(err) {
        if (!closed) {
            done(err);
            closed = true;
        }
    }

    function resolve() {
        if (!closed) {
            done();
            closed = true;
        }
    }

    _.forEach(functions, function(func) {
        if (closed) {
            return;
        }

        try {
            func.call(null, function(err) {
                if (err) {
                    reject(err);
                    return;
                }

                complete++;

                if (complete == wait) {
                    resolve();
                }
            })
        } catch (err) {
            reject(err);
            return;
        }
    });
};